      subroutine funder(nctri,z,costval,grad,iflag)

      use shared
      implicit none

      integer, intent(in) :: nctri
      double precision, intent(in), dimension(nctr) :: z
      double precision, intent(out) :: costval
      double precision, intent(out), dimension(nctr) :: grad
      integer, intent(out) :: iflag

! local variables
      double precision :: costu, costv, costp, zdotz
      double precision, dimension(nctr) :: x

! compute the function and gradient
	      x(1:ns) = MATMUL(sqrtPfU,z(1:ns)) + reshape(uback,(/ns/))
	      x(ns+1:2*ns) = MATMUL(sqrtPfV,z(ns+1:2*ns)) + reshape(vback,(/ns/))
	      x(2*ns+1:3*ns) = MATMUL(sqrtPfPhi,z(2*ns+1:3*ns)) + &
	                       reshape(phiback,(/ns/))

	      call convert_from_state(u, v, phi, x, n, m, nt, 1)
	      call swe_model(u(:,:,1:nt), v(:,:,1:nt), phi(:,:,1:nt), n, m, nt, 1, 1, nt)
	      call cost_4dvar(u, v, phi, n, m, nt, uobs, vobs, phiobs, costu, costv, costp, &
	           UObsStddev, VObsStddev, PhiObsStddev)

	      costval = costu + costv + costp

	      zdotz = dot_product(z,z)
	      costval = costval + zdotz

	      call stadj(uadj, vadj, phiadj, u, v, phi, uobs, vobs, &
	                       phiobs, UObsStddev, VObsStddev, PhiObsStddev, n, m, nt)

	      call convert_to_state(uadj, vadj, phiadj, grad, n, m, nt, 1)

	      grad(1:ns) = MATMUL(sqrtPfU,grad(1:ns))
	      grad(ns+1:2*ns) = MATMUL(sqrtPfV,grad(ns+1:2*ns))
	      grad(2*ns+1:3*ns) = MATMUL(sqrtPfPhi,grad(2*ns+1:3*ns))

	      grad = grad + 2*z

      return
      end

      subroutine funder_costonly(costval,z,nctri)

      implicit none

      double precision, intent(out) :: costval
      double precision, dimension(nctri), intent(in) :: z
      integer, intent(in) :: nctri
      double precision, dimension(nctri) :: fakegrad
      integer :: iflag

      call funder(nctri,z,costval,fakegrad,iflag)

      end

      subroutine funder_gradonly(grad,z,nctri)

      implicit none

      double precision, dimension(nctri), intent(out) :: grad
      double precision, dimension(nctri), intent(in) :: z
      integer, intent(in) :: nctri
      double precision :: fakecostval
      integer :: iflag

      call funder(nctri,z,fakecostval,grad,iflag)

      end
